
// Filename: element.hpp
// Author:   Nick Dingle & Will Knottenbelt {njd200,wjk}@doc.ic.ac.uk
// Date :    18th September 2002
// Notes:    Sparse matrix elements for HYDRA

class StateMatrixElement {
protected:
  long destination;
  double weight;

public:
  StateMatrixElement(long _destination, double _weight) {
    destination = _destination;
    weight = _weight;
  }
  StateMatrixElement() {};
  ~StateMatrixElement() {};

  inline long getDestination() const { return destination; }
  inline double getWeight() const { return weight; }

  inline void setDestination(long _destination) { destination = _destination; }
  inline void setWeight(double _weight) { weight = _weight; }
  friend ostream &operator<<(ostream &out, const StateMatrixElement &source);
};

class SteadyStateRowElement {
private:
  long column;
  double *index;
//  real entry;
public:
  inline long getColumn() { return column; }
  inline double *getIndex() { return index; }
  inline void setColumn(long _column) { column = _column; }
  inline void setIndex(double *_index) { index = _index; }
};

class SteadyStateColElement {
private:
  long row;
  double *index;
public:
  inline long getRow() { return row; }
  inline double *getIndex() { return index; }
  inline void setRow(long _row) { row = _row; }
  inline void setIndex(double *_index) { index = _index; }
};







