

// Filename: user.hpp
// Author:   Nick Dingle & Will Knottenbelt {njd200,wjk}@doc.ic.ac.uk
// Date :    18th September 2002
// Notes:    Definition of Access class (gives access to State)



enum StateType{VANISHING, TANGIBLE};

class State;

class Access {
private:
  State *__current;
public:
  Access();
  ~Access();

  void initial();
  int isEnabled(int *__en) const;
  int isTarget() const;
  int isExcluded() const;
  double passageWeight() const;
  void fire(int __t, Access *next) const;
  void computeStateMeasures(double *) const;
  void computeCountMeasures(int *, int, double *) const;
  double getTransWeight(int __t) const;
  //  complex<double> sojournTime(int __t, complex<double> __s) const;
  //  double distribution(int __t) const;
  int input(FILE *);
  int output(FILE *);
  //  void matrixOutput(FILE *);
  void output();
  //  void calcHashKeys(long &primary, long &secondary);
  long size();
  //  complex<double> markov(complex<double> __s) const;
  void computeHashKeys();
  unsigned long getPrimaryKey();
  unsigned long getSecondaryKey();
  StateType getType();
  int findEnabledTransitions();
  int getEnabledTransition(int __t);
  void fireEnabledTransition(int __t, Access *next);
  int numberChildren();
  int getNumberEnabled();
  void setKids(int __k);
  double getEnabledTransWeight(int __t);
  StateMatrixElement &getChild(int __t);
  double rateOut();
  //  double average(int __n) const;
  //  double nth_moment(const complex<double> &__S,int __trans, int __n, complex<double> __delta_s);
  double getTotalTransWeight();
  void setChild(int __t, long __value, double __weight);
  int matrixOutput(FILE *__mf);
  void calculateCountMeasures(double *__measures);
  int initialise(int, TransType *,int *);
};




